## jdupes 1.6

=== Makefile ===
# jdupes Makefile

#####################################################################
# Standand User Configuration Section                               #
#####################################################################

# PREFIX determines where files will be installed. Common examples
# include "/usr" or "/usr/local".
PREFIX = /usr

# Certain platforms do not support long options (command line options).
# To disable long options, uncomment the following line.
#CFLAGS += -DOMIT_GETOPT_LONG

# Uncomment for Linux with BTRFS support. Needed for -B/--dedupe.
# This can also be enabled at build time: 'make ENABLE_BTRFS=1'
#CFLAGS += -DENABLE_BTRFS

# Uncomment for low memory usage at the expense of speed and features
# This can be enabled at build time: 'make LOW_MEMORY=1'
#LOW_MEMORY=1

#####################################################################
# Developer Configuration Section                                   #
#####################################################################

# PROGRAM_NAME determines the installation name and manual page name
PROGRAM_NAME=jdupes

# BIN_DIR indicates directory where program is to be installed.
# Suggested value is "$(PREFIX)/bin"
BIN_DIR = $(PREFIX)/bin

# MAN_DIR indicates directory where the jdupes man page is to be
# installed. Suggested value is "$(PREFIX)/man/man1"
MAN_BASE_DIR = $(PREFIX)/share/man
MAN_DIR = $(MAN_BASE_DIR)/man1
MAN_EXT = 1

# Required External Tools
INSTALL = install	# install : UCB/GNU Install compatiable
#INSTALL = ginstall
RM      = rm -f
MKDIR   = mkdir -p
#MKDIR   = mkdirhier
#MKDIR   = mkinstalldirs

# Make Configuration
CC ?= gcc
COMPILER_OPTIONS = -Wall -Wextra -Wwrite-strings -Wcast-align -Wstrict-aliasing -pedantic -Wstrict-overflow -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Wstrict-overflow=5 -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2 -Winit-self
COMPILER_OPTIONS += -std=gnu99 -O2 -g -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe

#####################################################################
# no need to modify anything beyond this point                      #
#####################################################################

# Debugging code inclusion
ifdef LOUD
DEBUG=1
COMPILER_OPTIONS += -DLOUD_DEBUG
endif
ifdef DEBUG
COMPILER_OPTIONS += -DDEBUG
endif

# MinGW needs this for printf() conversions to work
ifeq ($(OS), Windows_NT)
ifndef NO_UNICODE
	UNICODE=1
	COMPILER_OPTIONS += -municode
endif
	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1
	OBJECT_FILES += win_stat.o
	override undefine ENABLE_BTRFS
	override undefine HAVE_BTRFS_IOCTL_H
endif

# Remap old BTRFS support option to new name
ifdef HAVE_BTRFS_IOCTL_H
ENABLE_BTRFS=1
endif
# New BTRFS support option
ifdef ENABLE_BTRFS
COMPILER_OPTIONS += -DENABLE_BTRFS
endif
# Low memory mode
ifdef LOW_MEMORY
COMPILER_OPTIONS += -DLOW_MEMORY -DJODY_HASH_WIDTH=32 -DSMA_PAGE_SIZE=32768
endif

CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)

INSTALL_PROGRAM = $(INSTALL) -c -m 0755
INSTALL_DATA    = $(INSTALL) -c -m 0644

# ADDITIONAL_OBJECTS - some platforms will need additional object files
# to support features not supplied by their vendor. Eg: GNU getopt()
#ADDITIONAL_OBJECTS += getopt.o

OBJECT_FILES += jdupes.o jody_hash.o string_malloc.o $(ADDITIONAL_OBJECTS)

all: jdupes

jdupes: $(OBJECT_FILES)
	$(CC) $(CFLAGS) $(LDFLAGS) -o jdupes $(OBJECT_FILES)

installdirs:
	test -d $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
	test -d $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)

install: jdupes installdirs
	$(INSTALL_PROGRAM)	jdupes   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
	$(INSTALL_DATA)		jdupes.1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

clean:
	$(RM) $(OBJECT_FILES) jdupes jdupes.exe *~ *.gcno *.gcda *.gcov

=== debian/changelog ===
jdupes (1.6-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 04 Dec 2016 09:14:17 -0200

jdupes (1.6-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable. Welcome to Debian!
  * debian/copyright: fixed a date about upstream source code.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 28 Nov 2016 09:31:20 -0200

jdupes (1.5.1-1) experimental; urgency=medium

  * New upstream release.
  * debian/watch: removed the opts line, no longer needed.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 01 Nov 2016 15:19:36 -0200

jdupes (1.5+git20161027.bc13175-1) experimental; urgency=medium

  * Initial release (Closes: #835554)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 27 Oct 2016 09:30:35 -0200

=== debian/control ===
Source: jdupes
Section: utils
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: debhelper (>= 10)
Standards-Version: 3.9.8
Homepage: https://github.com/jbruchon/jdupes
Vcs-Git: https://anonscm.debian.org/git/collab-maint/jdupes.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/jdupes.git

Package: jdupes
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: identify and delete duplicate files
 jdupes is a program based in fdupes. The main goal of jdupes is identify
 and taking actions upon duplicate files. In comparison with fdupes, jdupes
 is heavily modified from and improved.
 .
 The biggest reason to use jdupes is raw speed. In testing on various data
 sets, jdupes is over 7 times faster than fdupes-1.51 on average.
 .
 Code in jdupes is written with data loss avoidance as the highest priority.
 If a choice must be made between being aggressive or careful, the careful
 way is always chosen.
 .
 jdupes includes features that are not found in fdupes. Examples of such
 features include btrfs block-level deduplication and control over which
 file is kept when a match set is automatically deleted. jdupes is not
 afraid of dropping features of low value; a prime example is the -1 switch
 which outputs all matches in a set on one line, a feature which was found
 to be useless in real-world tests and therefore thrown out.
 .
 jdupes can convert duplicate files in hardlinks or relative softlinks. It
 is useful in several scenarios, as in Debian packaging, to create relative
 symlinks to lots of duplicate files.

=== debian/watch ===
version=4
https://github.com/jbruchon/jdupes/releases .*/archive/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## jdupes 1.6.2

=== Makefile ===
--- 
+++ 
@@ -98,7 +98,7 @@
 # to support features not supplied by their vendor. Eg: GNU getopt()
 #ADDITIONAL_OBJECTS += getopt.o
 
-OBJECT_FILES += jdupes.o jody_hash.o string_malloc.o $(ADDITIONAL_OBJECTS)
+OBJECT_FILES += jdupes.o jody_hash.o jody_paths.o jody_sort.o string_malloc.o $(ADDITIONAL_OBJECTS)
 
 all: jdupes

## jdupes 1.7

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 #####################################################################
 
 # PROGRAM_NAME determines the installation name and manual page name
-PROGRAM_NAME=jdupes
+PROGRAM_NAME = jdupes
 
 # BIN_DIR indicates directory where program is to be installed.
 # Suggested value is "$(PREFIX)/bin"
@@ -98,20 +98,22 @@
 # to support features not supplied by their vendor. Eg: GNU getopt()
 #ADDITIONAL_OBJECTS += getopt.o
 
-OBJECT_FILES += jdupes.o jody_hash.o jody_paths.o jody_sort.o string_malloc.o $(ADDITIONAL_OBJECTS)
+OBJECT_FILES += jdupes.o jody_hash.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
+OBJECT_FILES += act_deletefiles.o act_dedupefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
+OBJECT_FILES += $(ADDITIONAL_OBJECTS)
 
 all: jdupes
 
 jdupes: $(OBJECT_FILES)
-	$(CC) $(CFLAGS) $(LDFLAGS) -o jdupes $(OBJECT_FILES)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJECT_FILES)
 
 installdirs:
 	test -d $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
 	test -d $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)
 
 install: jdupes installdirs
-	$(INSTALL_PROGRAM)	jdupes   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
-	$(INSTALL_DATA)		jdupes.1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)
+	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
+	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)
 
 clean:
-	$(RM) $(OBJECT_FILES) jdupes jdupes.exe *~ *.gcno *.gcda *.gcov
+	$(RM) $(OBJECT_FILES) $(PROGRAM_NAME) jdupes.exe *~ *.gcno *.gcda *.gcov

=== debian/changelog ===
jdupes (1.7-2+deb9u1) stretch; urgency=medium

  * debian/patches/20_fix-crash-arm.patch: add to fix a potential crash in
    ARM. Thanks to Jody Bruchon <jody@jodybruchon.com>. (Closes: #914078)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 19 Nov 2018 00:10:16 -0200

jdupes (1.7-2) unstable; urgency=medium

  * debian/patches/10_fix-segfault.patch: added to fix a segmentation fault in
    jdupes. (Closes: #854427)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 06 Feb 2017 22:19:51 -0200

jdupes (1.7-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable. See the previous changelog for details.
    (Closes: #848360)
  * debian/patches/10_use-program-name-variable.patch: dropped. The upstream
    fixed the source code. Thanks!
  * debian/README.Debian: added a new information.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 03 Jan 2017 17:30:04 -0200

jdupes (1.6.2-4) experimental; urgency=medium

  * Using a single package again, as suggested by Christoph Anton Mitterer
    <calestyo@scientia.net>. It will solve #848360 when uploaded to Sid.
    Consequently:
      - Changed debian/rules to build with BTRFS when over Linux.
      - Removed debian/jdupes.install and debian/jdupes-btrfs.*
      - Renamed debian/jdupes.docs to debian/docs.
      - Renamed debian/README.source to debian/README.Debian. Updated all
        information.
  * debian/control:
      - Added a Conflicts, Provides and Replaces fields to uninstall any
        jdupes-btrfs from the system.
      - Improved the description.
      - Removed the package jdupes-btrfs.
  * debian/copyright: updated the packaging copyright years.
  * debian/patches/10_use-program-name-variable.patch.txt: a mistake. Removed.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 02 Jan 2017 19:52:54 -0200

jdupes (1.6.2-3) unstable; urgency=medium

  * debian/rules: added a condition to select when jdupes-btrfs will
    be built or not, fixing a FTBFS in Hurd/kFreeBSD-*. Thanks a lot
    to Aaron M. Ucko <ucko@debian.org>. (Closes: #848244)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 15 Dec 2016 14:05:21 -0200

jdupes (1.6.2-2) unstable; urgency=medium

  * Created a new binary: jdupes-btrfs. See debian/README.source in source code
    of this package for details. To create the new binary, the following files
    were created or changed:
      - debian/control (changed).
      - debian/docs: renamed to jdupes.docs and jdupes-btrfs.docs.
      - debian/jdupes-btrfs.install (created).
      - debian/jdupes-btrfs.manpages (created).
      - debian/jdupes.install (created).
      - debian/patches/10_use-program-name-variable.patch (created).
      - debian/README.source (created).
      - debian/rules (changed).

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 14 Dec 2016 17:10:04 -0200

jdupes (1.6.2-1) unstable; urgency=medium

  * New upstream release.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 03 Dec 2016 13:56:52 -0200

jdupes (1.6.1-1) UNRELEASED; urgency=medium

  * New upstream release. (Closes: #846255)
  * debian/control: improved the long description.
  * debian/copyright: updated to include some new rights.
  * debian/rules: added the DEB_CFLAGS_MAINT_APPEND variable
    to enable the support to BTRFS. (Closes: #846255)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 02 Dec 2016 21:33:27 -0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,10 @@
 Package: jdupes
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: identify and delete duplicate files
+Provides: jdupes-btrfs
+Conflicts: jdupes-btrfs
+Replaces: jdupes-btrfs
+Description: identify and delete or link duplicate files
  jdupes is a program based in fdupes. The main goal of jdupes is identify
  and taking actions upon duplicate files. In comparison with fdupes, jdupes
  is heavily modified from and improved.
@@ -32,4 +35,7 @@
  .
  jdupes can convert duplicate files in hardlinks or relative softlinks. It
  is useful in several scenarios, as in Debian packaging, to create relative
- symlinks to lots of duplicate files.
+ symlinks to lots of duplicate files (it will substitute rdfind + symlinks
+ commands, used to same purpose, when solving lintian duplicate-files).
+ .
+ Packages build for Linux versions have support to btrfs filesystem.

## jdupes 1.8

=== Makefile ===
--- 
+++ 
@@ -19,6 +19,10 @@
 # Uncomment for low memory usage at the expense of speed and features
 # This can be enabled at build time: 'make LOW_MEMORY=1'
 #LOW_MEMORY=1
+
+# Uncomment this to build in hardened mode.
+# This can be enabled at build time: 'make HARDEN=1'
+#HARDEN=1
 
 #####################################################################
 # Developer Configuration Section                                   #
@@ -63,6 +67,10 @@
 ifdef DEBUG
 COMPILER_OPTIONS += -DDEBUG
 endif
+ifdef HARDEN
+COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
+endif
+
 
 # MinGW needs this for printf() conversions to work
 ifeq ($(OS), Windows_NT)
@@ -83,6 +91,7 @@
 # New BTRFS support option
 ifdef ENABLE_BTRFS
 COMPILER_OPTIONS += -DENABLE_BTRFS
+OBJECT_FILES += act_dedupefiles.o
 endif
 # Low memory mode
 ifdef LOW_MEMORY
@@ -99,7 +108,8 @@
 #ADDITIONAL_OBJECTS += getopt.o
 
 OBJECT_FILES += jdupes.o jody_hash.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
-OBJECT_FILES += act_deletefiles.o act_dedupefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
+OBJECT_FILES += jody_cacheinfo.o
+OBJECT_FILES += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
 OBJECT_FILES += $(ADDITIONAL_OBJECTS)
 
 all: jdupes
@@ -117,3 +127,9 @@
 
 clean:
 	$(RM) $(OBJECT_FILES) $(PROGRAM_NAME) jdupes.exe *~ *.gcno *.gcda *.gcov
+
+distclean: clean
+	$(RM) *.pkg.tar.xz
+
+package:
+	+./chroot_build.sh

=== debian/changelog ===
jdupes (1.8-1) unstable; urgency=medium

  * New upstream release.
  * debian/clean: created to remove a file forgotten by the upstream.
  * debian/control: bumped Standards-Version to 4.0.0.
  * debian/copyright:
      - All upstream files are unde MIT license now.
      - Updated the upstream copyright years.
  * debian/patches/10_fix-segfault.patch: removed. This patch was previously
    supplied by the upstream and it is already in 1.8 source code.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 20 Jul 2017 10:44:07 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper (>= 10)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/jdupes.git
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/jdupes.git

## jdupes 1.9

=== Makefile ===
--- 
+++ 
@@ -51,7 +51,7 @@
 
 # Make Configuration
 CC ?= gcc
-COMPILER_OPTIONS = -Wall -Wextra -Wwrite-strings -Wcast-align -Wstrict-aliasing -pedantic -Wstrict-overflow -Wstrict-prototypes -Wpointer-arith -Wundef
+COMPILER_OPTIONS = -Wall -Wextra -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-overflow -Wstrict-prototypes -Wpointer-arith -Wundef
 COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Wstrict-overflow=5 -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2 -Winit-self
 COMPILER_OPTIONS += -std=gnu99 -O2 -g -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
 
@@ -71,6 +71,13 @@
 COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
 endif
 
+# Catch someone trying to enable BTRFS in flags and turn on ENABLE_BTRFS
+ifneq (,$(findstring DENABLE_BTRFS,$(CFLAGS)))
+	ENABLE_BTRFS=1
+endif
+ifneq (,$(findstring DENABLE_BTRFS,$(CFLAGS_EXTRA)))
+	ENABLE_BTRFS=1
+endif
 
 # MinGW needs this for printf() conversions to work
 ifeq ($(OS), Windows_NT)
@@ -79,7 +86,7 @@
 	COMPILER_OPTIONS += -municode
 endif
 	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1
-	OBJECT_FILES += win_stat.o
+	OBJS += win_stat.o
 	override undefine ENABLE_BTRFS
 	override undefine HAVE_BTRFS_IOCTL_H
 endif
@@ -91,7 +98,9 @@
 # New BTRFS support option
 ifdef ENABLE_BTRFS
 COMPILER_OPTIONS += -DENABLE_BTRFS
-OBJECT_FILES += act_dedupefiles.o
+OBJS += act_dedupefiles.o
+else
+OBJS_CLEAN += act_dedupefiles.o
 endif
 # Low memory mode
 ifdef LOW_MEMORY
@@ -100,33 +109,33 @@
 
 CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
 
-INSTALL_PROGRAM = $(INSTALL) -c -m 0755
-INSTALL_DATA    = $(INSTALL) -c -m 0644
+INSTALL_PROGRAM = $(INSTALL) -m 0755
+INSTALL_DATA    = $(INSTALL) -m 0644
 
 # ADDITIONAL_OBJECTS - some platforms will need additional object files
 # to support features not supplied by their vendor. Eg: GNU getopt()
 #ADDITIONAL_OBJECTS += getopt.o
 
-OBJECT_FILES += jdupes.o jody_hash.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
-OBJECT_FILES += jody_cacheinfo.o
-OBJECT_FILES += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
-OBJECT_FILES += $(ADDITIONAL_OBJECTS)
+OBJS += jdupes.o jody_hash.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
+OBJS += jody_cacheinfo.o
+OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
+OBJS += $(ADDITIONAL_OBJECTS)
 
 all: jdupes
 
-jdupes: $(OBJECT_FILES)
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJECT_FILES)
+jdupes: $(OBJS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)
 
 installdirs:
-	test -d $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
-	test -d $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)
+	test -e $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
+	test -e $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)
 
 install: jdupes installdirs
 	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
 	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)
 
 clean:
-	$(RM) $(OBJECT_FILES) $(PROGRAM_NAME) jdupes.exe *~ *.gcno *.gcda *.gcov
+	$(RM) $(OBJS) $(OBJS_CLEAN) $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov
 
 distclean: clean
 	$(RM) *.pkg.tar.xz

=== debian/changelog ===
jdupes (1.9-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bumped Standards-Version to 4.1.1.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 04 Dec 2017 17:49:32 -0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper (>= 10)
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/jdupes.git
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/jdupes.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH_OS),linux)
      export OPTS="ENABLE_BTRFS=1"
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(OPTS)

## jdupes 1.10.2

=== Makefile ===
--- 
+++ 
@@ -85,15 +85,20 @@
 	UNICODE=1
 	COMPILER_OPTIONS += -municode
 endif
-	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1
+	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
 	OBJS += win_stat.o
 	override undefine ENABLE_BTRFS
-	override undefine HAVE_BTRFS_IOCTL_H
 endif
 
-# Remap old BTRFS support option to new name
-ifdef HAVE_BTRFS_IOCTL_H
-ENABLE_BTRFS=1
+# xxHash support
+ifdef USE_XXHASH
+COMPILER_OPTIONS += -DUSE_HASH_XXHASH64
+OBJS += xxhash.o
+OBJS_CLEAN += jody_hash.o
+else
+COMPILER_OPTIONS += -DUSE_HASH_JODYHASH
+OBJS += jody_hash.o
+OBJS_CLEAN += xxhash.o
 endif
 # New BTRFS support option
 ifdef ENABLE_BTRFS
@@ -104,7 +109,7 @@
 endif
 # Low memory mode
 ifdef LOW_MEMORY
-COMPILER_OPTIONS += -DLOW_MEMORY -DJODY_HASH_WIDTH=32 -DSMA_PAGE_SIZE=32768
+COMPILER_OPTIONS += -DLOW_MEMORY -DJODY_HASH_WIDTH=32 -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_USER_ORDER
 endif
 
 CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
@@ -116,7 +121,7 @@
 # to support features not supplied by their vendor. Eg: GNU getopt()
 #ADDITIONAL_OBJECTS += getopt.o
 
-OBJS += jdupes.o jody_hash.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
+OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
 OBJS += jody_cacheinfo.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
 OBJS += $(ADDITIONAL_OBJECTS)
@@ -134,6 +139,8 @@
 	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
 	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)
 
+test:
+	./test.sh
 clean:
 	$(RM) $(OBJS) $(OBJS_CLEAN) $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov

=== debian/changelog ===
jdupes (1.10.2-1) unstable; urgency=medium

  * New upstream release.
  * Migrated DH level to 11.
  * debian/clean: no longer needed. Removed.
  * debian/control:
      - Bumped Standards-Version to 4.2.0.
      - Changed Vcs-* URLs to salsa.debian.org.
  * debian/copyright:
      - Added rights for Yann Collet.
      - Updated upstream and packaging years.
  * debian/docs:
      - Added OLD_CHANGES and OLD_CONTRIBUTORS.
      - Removed no longer existent TODO.
  * debian/patches/10-disable_test.patch: created to disable a wrong test.
  * debian/tests: created to perform tests.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 20 Aug 2018 22:22:01 -0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: utils
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper (>= 10)
-Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 11)
+Standards-Version: 4.2.0
 Homepage: https://github.com/jbruchon/jdupes
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/jdupes.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/jdupes.git
+Vcs-Browser: https://salsa.debian.org/debian/jdupes
+Vcs-Git: https://salsa.debian.org/debian/jdupes.git
 
 Package: jdupes
 Architecture: any

=== debian/tests/control ===
Test-Command: jdupes debian/tests/
Depends: @

## jdupes 1.11.1

=== debian/changelog ===
jdupes (1.11.1-2) unstable; urgency=medium

  * debian/tests/control: added a new test.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 28 Nov 2018 22:38:07 -0200

jdupes (1.11.1-1) unstable; urgency=medium

  * New upstream version 1.11.1
  * debian/docs: removed no longer existent files OLD_CHANGES and
    OLD_CONTRIBUTORS.
  * debian/patches/10-disable_test.patch: removed in favor of an override add
    to debian/rules.
  * debian/rules: added override_dh_auto_test target as a substitute for the
    patch 10-disable_test.patch.
  * debian/tests/control: removed no longer needed redirection to stderr. The
    upstream fixed the source code. Thanks!

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 18 Nov 2018 21:09:54 -0200

jdupes (1.10.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/20-fix_manpage.patch: removed.
    The upstream fixed the source code. Thanks.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 25 Sep 2018 23:04:56 -0300

jdupes (1.10.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bumped Standards-Version to 4.2.1.
  * debian/patches/20-fix_manpage.patch: added to fix a possible macro.
  * debian/tests/:
      - control:
          ~ Improved the test.
          ~ Removed unnecessary field Depends.
      - files/*: added to help improve the test.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 07 Sep 2018 21:56:50 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper (>= 11)
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes
 Vcs-Git: https://salsa.debian.org/debian/jdupes.git

## jdupes 1.12

=== Makefile ===
--- 
+++ 
@@ -45,6 +45,7 @@
 INSTALL = install	# install : UCB/GNU Install compatiable
 #INSTALL = ginstall
 RM      = rm -f
+RMDIR	= rmdir -p
 MKDIR   = mkdir -p
 #MKDIR   = mkdirhier
 #MKDIR   = mkinstalldirs
@@ -58,6 +59,13 @@
 #####################################################################
 # no need to modify anything beyond this point                      #
 #####################################################################
+
+# Set built-on date for display in program version info screen
+ifdef EMBED_BUILD_DATE
+BD=$(shell date +"\"%Y-%m-%d %H:%M:%S %z\"")
+$(shell echo "#define BUILT_ON_DATE \"$(BD)\"" > build_date.h)
+COMPILER_OPTIONS += -DBUILD_DATE
+endif
 
 # Debugging code inclusion
 ifdef LOUD
@@ -84,22 +92,13 @@
 ifndef NO_UNICODE
 	UNICODE=1
 	COMPILER_OPTIONS += -municode
+	PROGRAM_SUFFIX=.exe
 endif
 	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
-	OBJS += win_stat.o
+	OBJS += win_stat.o winres.o
 	override undefine ENABLE_BTRFS
 endif
 
-# xxHash support
-ifdef USE_XXHASH
-COMPILER_OPTIONS += -DUSE_HASH_XXHASH64
-OBJS += xxhash.o
-OBJS_CLEAN += jody_hash.o
-else
-COMPILER_OPTIONS += -DUSE_HASH_JODYHASH
-OBJS += jody_hash.o
-OBJS_CLEAN += xxhash.o
-endif
 # New BTRFS support option
 ifdef ENABLE_BTRFS
 COMPILER_OPTIONS += -DENABLE_BTRFS
@@ -109,7 +108,7 @@
 endif
 # Low memory mode
 ifdef LOW_MEMORY
-COMPILER_OPTIONS += -DLOW_MEMORY -DJODY_HASH_WIDTH=32 -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_USER_ORDER
+COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_USER_ORDER
 endif
 
 CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
@@ -124,25 +123,45 @@
 OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
 OBJS += jody_cacheinfo.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
+OBJS += xxhash.o
 OBJS += $(ADDITIONAL_OBJECTS)
 
-all: jdupes
+OBJS_CLEAN += jdupes-standalone
 
-jdupes: $(OBJS)
+all: $(PROGRAM_NAME)
+
+$(PROGRAM_NAME): $(OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)
+
+winres.o : winres.rc winres.manifest.xml
+	windres winres.rc winres.o
+
+standalone: jdupes-standalone
 
 installdirs:
 	test -e $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
 	test -e $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)
 
-install: jdupes installdirs
+install: $(PROGRAM_NAME) installdirs
 	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
 	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)
 
+uninstalldirs:
+	-test -e $(DESTDIR)$(BIN_DIR) && $(RMDIR) $(DESTDIR)$(BIN_DIR)
+	-test -e $(DESTDIR)$(MAN_DIR) && $(RMDIR) $(DESTDIR)$(MAN_DIR)
+
+uninstall: uninstalldirs
+	$(RM)	$(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)
+	$(RM)	$(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)
+
 test:
 	./test.sh
+
+stripped: $(PROGRAM_NAME)
+	strip $(PROGRAM_NAME)$(PROGRAM_SUFFIX)
+
 clean:
-	$(RM) $(OBJS) $(OBJS_CLEAN) $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov
+	$(RM) $(OBJS) $(OBJS_CLEAN) build_date.h $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov
 
 distclean: clean
 	$(RM) *.pkg.tar.xz

=== debian/changelog ===
jdupes (1.12-1) unstable; urgency=medium

  * New upstream version 1.12.
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 12.
  * debian/control: bumped Standards-Version to 4.3.0.
  * debian/copyright: updated upstream and packaging copyright years.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 26 Feb 2019 11:42:47 -0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper (>= 11)
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 12)
+Standards-Version: 4.3.0
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes
 Vcs-Git: https://salsa.debian.org/debian/jdupes.git

=== debian/rules ===
--- 
+++ 
@@ -12,3 +12,5 @@
 
 override_dh_auto_build:
 	dh_auto_build -- $(OPTS)
+
+override_dh_auto_test:

=== debian/tests/control ===
Test-Command: jdupes debian/tests/files/

Test-Command: jdupes -r testdir

## jdupes 1.13.1

=== debian/changelog ===
jdupes (1.13.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 08 Jul 2019 00:27:06 -0300

jdupes (1.13.1-1) experimental; urgency=medium

  * New upstream version 1.13.1.
  * debian/copyright: updated upstream copyright years.
  * debian/docs: changed from README to README.md.
  * debian/README.Debian: fixed a typo.
  * debian/rules: added a new override to install
    files inside /usr dir instead of /usr/local place.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 28 Jun 2019 08:15:44 -0300

## jdupes 1.13.2

=== debian/changelog ===
jdupes (1.13.2-1) unstable; urgency=medium

  * New upstream version 1.13.2.
  * debian/control: bumped Standards-Version to 4.4.0.
  * debian/tests/control:
      - Added a new test using several options from jdupes.
      - Added a notice about testdir.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 05 Aug 2019 19:45:24 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes
 Vcs-Git: https://salsa.debian.org/debian/jdupes.git

=== debian/rules ===
--- 
+++ 
@@ -13,4 +13,7 @@
 override_dh_auto_build:
 	dh_auto_build -- $(OPTS)
 
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=/usr
+
 override_dh_auto_test:

## jdupes 1.14.0

=== Makefile ===
--- 
+++ 
@@ -6,15 +6,15 @@
 
 # PREFIX determines where files will be installed. Common examples
 # include "/usr" or "/usr/local".
-PREFIX = /usr
+PREFIX = /usr/local
 
 # Certain platforms do not support long options (command line options).
 # To disable long options, uncomment the following line.
 #CFLAGS += -DOMIT_GETOPT_LONG
 
-# Uncomment for Linux with BTRFS support. Needed for -B/--dedupe.
-# This can also be enabled at build time: 'make ENABLE_BTRFS=1'
-#CFLAGS += -DENABLE_BTRFS
+# Uncomment for Linux for -B/--dedupe.
+# This can also be enabled at build time: 'make ENABLE_DEDUPE=1'
+#CFLAGS += -DENABLE_DEDUPE
 
 # Uncomment for low memory usage at the expense of speed and features
 # This can be enabled at build time: 'make LOW_MEMORY=1'
@@ -55,6 +55,7 @@
 COMPILER_OPTIONS = -Wall -Wextra -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-overflow -Wstrict-prototypes -Wpointer-arith -Wundef
 COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Wstrict-overflow=5 -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2 -Winit-self
 COMPILER_OPTIONS += -std=gnu99 -O2 -g -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
+COMPILER_OPTIONS += -DSMA_MAX_FREE=11
 
 #####################################################################
 # no need to modify anything beyond this point                      #
@@ -74,17 +75,19 @@
 endif
 ifdef DEBUG
 COMPILER_OPTIONS += -DDEBUG
+else
+COMPILER_OPTIONS += -DNDEBUG
 endif
 ifdef HARDEN
 COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
 endif
 
-# Catch someone trying to enable BTRFS in flags and turn on ENABLE_BTRFS
-ifneq (,$(findstring DENABLE_BTRFS,$(CFLAGS)))
-	ENABLE_BTRFS=1
+# Catch someone trying to enable BTRFS in flags and turn on ENABLE_DEDUPE
+ifneq (,$(findstring DENABLE_BTRFS,$(CFLAGS) $(CFLAGS_EXTRA)))
+	ENABLE_DEDUPE=1
 endif
-ifneq (,$(findstring DENABLE_BTRFS,$(CFLAGS_EXTRA)))
-	ENABLE_BTRFS=1
+ifneq (,$(findstring DENABLE_DEDUPE,$(CFLAGS) $(CFLAGS_EXTRA)))
+	ENABLE_DEDUPE=1
 endif
 
 # MinGW needs this for printf() conversions to work
@@ -96,16 +99,28 @@
 endif
 	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
 	OBJS += win_stat.o winres.o
-	override undefine ENABLE_BTRFS
+	override undefine ENABLE_DEDUPE
 endif
 
-# New BTRFS support option
+# Compatibility mappings for dedupe feature
 ifdef ENABLE_BTRFS
-COMPILER_OPTIONS += -DENABLE_BTRFS
+ENABLE_DEDUPE=1
+endif
+ifdef STATIC_BTRFS_H
+STATIC_DEDUPE_H=1
+endif
+
+# Dedupe feature (originally only BTRFS, now generalized)
+ifdef ENABLE_DEDUPE
+COMPILER_OPTIONS += -DENABLE_DEDUPE
 OBJS += act_dedupefiles.o
 else
 OBJS_CLEAN += act_dedupefiles.o
 endif
+ifdef STATIC_DEDUPE_H
+COMPILER_OPTIONS += -DSTATIC_DEDUPE_H
+endif
+
 # Low memory mode
 ifdef LOW_MEMORY
 COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_USER_ORDER
@@ -122,7 +137,7 @@
 
 OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
 OBJS += jody_cacheinfo.o
-OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o
+OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
 OBJS += xxhash.o
 OBJS += $(ADDITIONAL_OBJECTS)
 
@@ -134,6 +149,7 @@
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)
 
 winres.o : winres.rc winres.manifest.xml
+	./tune_winres.sh
 	windres winres.rc winres.o
 
 standalone: jdupes-standalone

=== debian/changelog ===
jdupes (1.14.0-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/copyright: updated packaging copyright years.
  * debian/patches/010_fix-FTBFS-Hurd.patch: added to define PATH_MAX variable
    to fix a FTBFS in Hurd.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 06 Jan 2020 09:50:11 -0300

jdupes (1.14.0-1) experimental; urgency=medium

  * New upstream version 1.14.0.
  * debian/copyright:
      - Added rights for Oracle from new file dedupe-static.h.
      - Updated copyright years for Adrian Lopez (data changed by upstream).
      - Using GitHub/issues address in Upstream-Contact field.
  * debian/rules:
      - Added STATIC_DEDUPE_H=1 to $OPTS (see INSTALL file in upstream place).
      - Changed from ENABLE_BTRFS=1 to ENABLE_DEDUPE=1 in $OPTS because it is
        the new name for the variable.
      - Split $OPTS to $OPT1 and $OPT2.
  * debian/salsa-ci.yml: added to provide CI tests for Salsa.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 31 Dec 2019 00:57:29 -0300

jdupes (1.13.2-2) unstable; urgency=medium

  * debian/control:
      - Added Rules-Requires-Root: no to source stanza.
      - Bumped Standards-Version to 4.4.1.
      - Set Multi-Arch: foreign. Thanks to Helmut Grohne <helmut@subdivi.de>.
        (Closes: #941588)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 02 Oct 2019 14:24:32 -0300

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,15 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes
 Vcs-Git: https://salsa.debian.org/debian/jdupes.git
 
 Package: jdupes
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Provides: jdupes-btrfs
 Conflicts: jdupes-btrfs

=== debian/tests/control ===
Test-Command: jdupes debian/tests/files/

# testdir is a test directory provided by the upstream
Test-Command: jdupes -r testdir

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP; jdupes -r1AHilsptz $AUTOPKGTEST_TMP/files

## jdupes 1.18.1

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # To disable long options, uncomment the following line.
 #CFLAGS += -DOMIT_GETOPT_LONG
 
-# Uncomment for Linux for -B/--dedupe.
+# Uncomment for -B/--dedupe.
 # This can also be enabled at build time: 'make ENABLE_DEDUPE=1'
 #CFLAGS += -DENABLE_DEDUPE
 
@@ -123,7 +123,7 @@
 
 # Low memory mode
 ifdef LOW_MEMORY
-COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_USER_ORDER
+COMPILER_OPTIONS += -DLOW_MEMORY -DSMA_PAGE_SIZE=32768 -DCHUNK_SIZE=16384 -DNO_HARDLINKS -DNO_SYMLINKS -DNO_USER_ORDER -DNO_PERMS
 endif
 
 CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
@@ -135,7 +135,7 @@
 # to support features not supplied by their vendor. Eg: GNU getopt()
 #ADDITIONAL_OBJECTS += getopt.o
 
-OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o string_malloc.o
+OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o jody_strtoepoch.o string_malloc.o
 OBJS += jody_cacheinfo.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
 OBJS += xxhash.o
@@ -144,6 +144,13 @@
 OBJS_CLEAN += jdupes-standalone
 
 all: $(PROGRAM_NAME)
+
+static: $(PROGRAM_NAME)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS) -static
+
+static_stripped: $(PROGRAM_NAME)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS) -static
+	strip $(PROGRAM_NAME)
 
 $(PROGRAM_NAME): $(OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)
@@ -181,6 +188,12 @@
 
 distclean: clean
 	$(RM) *.pkg.tar.xz
+	$(RM) -r jdupes-*-win*/ jdupes-*-win*.zip
+	$(RM) -r jdupes-*-mac*/ jdupes-*-mac*.zip
 
 package:
 	+./chroot_build.sh
+winpackage:
+	+./generate_windows_packages.sh
+macpackage:
+	+./generate_mac_packages.sh

=== debian/changelog ===
jdupes (1.18.1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 15 Jul 2020 17:56:23 -0300

jdupes (1.18.1-1) unstable; urgency=medium

  * New upstream version 1.18.1.
  * debian/tests/control: use native 'tree' command to make two CI tests
    cross-test-friendly for Ubuntu. See more details in #946361.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 11 Jul 2020 23:07:32 -0300

jdupes (1.17.1-1) unstable; urgency=medium

  * New upstream version 1.17.1.
  * debian/copyright: updated because the upstream file called dedupe-static.h
    was renamed to linux-dedupe-static.h.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 03 Jul 2020 22:47:33 -0300

jdupes (1.17.0-1) unstable; urgency=medium

  * New upstream version 1.17.0.
  * debian/control: removed no longer needed Provides, Conflicts, Replaces
    fields.
  * debian/source/include-binaries: created to list new binary files to be
    used for CI tests.
  * debian/tests/*: created new tests and improved some old tests.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 25 Jun 2020 13:24:50 -0300

jdupes (1.16.0-1) unstable; urgency=medium

  * New upstream version 1.16.0. (Closes: #866246)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 15 Jun 2020 14:10:33 -0300

jdupes (1.15.0-1) unstable; urgency=medium

  * New upstream version 1.15.0.
  * debian/copyright: updated upstream copyright years.
  * debian/patches/010_fix-FTBFS-Hurd.patch: removed.
    The upstream fixed the source code. Thanks!
  * debian/tests/control: added a break line.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 25 May 2020 01:00:05 -0300

jdupes (1.14.0-3) unstable; urgency=medium

  [ Joao Eriberto Mota Filho ]
  * Migrated DH level to 13.

  [ Debian Janitor ]
  * Update standards version to 4.5.0, no changes needed.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 30 Apr 2020 00:25:22 -0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes
@@ -13,9 +13,6 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Provides: jdupes-btrfs
-Conflicts: jdupes-btrfs
-Replaces: jdupes-btrfs
 Description: identify and delete or link duplicate files
  jdupes is a program based in fdupes. The main goal of jdupes is identify
  and taking actions upon duplicate files. In comparison with fdupes, jdupes

=== debian/tests/control ===
Test-Command: jdupes -v
Restrictions: superficial

Test-Command: jdupes debian/tests/files/

Test-Command: jdupes -m debian/tests/files/

Test-Command: jdupes -M debian/tests/files/

Test-Command: jdupes -r0 debian/tests/files/

Test-Command: jdupes -mr debian/tests/files/

Test-Command: jdupes -ru debian/tests/files/

# testdir is a test directory provided by the upstream
Test-Command: jdupes -r testdir

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@1ADHinprlsT $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/
Depends: @, tree:native

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@rdNQzo time  -X size+:15 $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/
Depends: @, tree:native

## jdupes 1.18.2

=== debian/changelog ===
jdupes (1.18.2-1) unstable; urgency=medium

  * New upstream version 1.18.2.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 25 Jul 2020 15:34:01 -0300

## jdupes 1.19.1

=== Makefile ===
--- 
+++ 
@@ -52,8 +52,8 @@
 
 # Make Configuration
 CC ?= gcc
-COMPILER_OPTIONS = -Wall -Wextra -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-overflow -Wstrict-prototypes -Wpointer-arith -Wundef
-COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Wstrict-overflow=5 -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2 -Winit-self
+COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
+COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
 COMPILER_OPTIONS += -std=gnu99 -O2 -g -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
 COMPILER_OPTIONS += -DSMA_MAX_FREE=11
 
@@ -61,11 +61,10 @@
 # no need to modify anything beyond this point                      #
 #####################################################################
 
-# Set built-on date for display in program version info screen
-ifdef EMBED_BUILD_DATE
-BD=$(shell date +"\"%Y-%m-%d %H:%M:%S %z\"")
-$(shell echo "#define BUILT_ON_DATE \"$(BD)\"" > build_date.h)
-COMPILER_OPTIONS += -DBUILD_DATE
+# Don't use unsupported compiler options on gcc 3/4 (OS X 10.5.8 Xcode)
+GCCVERSION = $(shell expr `gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
+ifeq "$(GCCVERSION)" "1"
+	COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
 endif
 
 # Debugging code inclusion
@@ -90,16 +89,31 @@
 	ENABLE_DEDUPE=1
 endif
 
+UNAME_S=$(shell uname -s)
+
 # MinGW needs this for printf() conversions to work
 ifeq ($(OS), Windows_NT)
-ifndef NO_UNICODE
-	UNICODE=1
-	COMPILER_OPTIONS += -municode
-	PROGRAM_SUFFIX=.exe
-endif
+	ifndef NO_UNICODE
+		UNICODE=1
+		COMPILER_OPTIONS += -municode
+		PROGRAM_SUFFIX=.exe
+	endif
 	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
-	OBJS += win_stat.o winres.o
+	OBJS += win_stat.o
+	ifeq ($(UNAME_S), MINGW32_NT-5.1)
+		OBJS += winres_xp.o
+	else
+		OBJS += winres.o
+	endif
 	override undefine ENABLE_DEDUPE
+endif
+
+# Don't do clonefile on Mac OS X < 10.13 (High Sierra)
+ifeq ($(UNAME_S), Darwin)
+	DARWINVER := $(shell expr `uname -r | cut -d. -f1` \< 17)
+	ifeq "$(DARWINVER)" "1"
+		COMPILER_OPTIONS += -DNO_CLONEFILE=1
+	endif
 endif
 
 # Compatibility mappings for dedupe feature
@@ -135,14 +149,12 @@
 # to support features not supplied by their vendor. Eg: GNU getopt()
 #ADDITIONAL_OBJECTS += getopt.o
 
-OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o jody_strtoepoch.o string_malloc.o
+OBJS += jdupes.o jody_paths.o jody_sort.o jody_win_unicode.o jody_strtoepoch.o string_malloc.o oom.o
 OBJS += jody_cacheinfo.o
 OBJS += act_deletefiles.o act_linkfiles.o act_printmatches.o act_summarize.o act_printjson.o
 OBJS += xxhash.o
 OBJS += $(ADDITIONAL_OBJECTS)
 
-OBJS_CLEAN += jdupes-standalone
-
 all: $(PROGRAM_NAME)
 
 static: $(PROGRAM_NAME)
@@ -155,11 +167,13 @@
 $(PROGRAM_NAME): $(OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)
 
-winres.o : winres.rc winres.manifest.xml
+winres.o: winres.rc winres.manifest.xml
 	./tune_winres.sh
 	windres winres.rc winres.o
 
-standalone: jdupes-standalone
+winres_xp.o: winres_xp.rc
+	./tune_winres.sh
+	windres winres_xp.rc winres_xp.o
 
 installdirs:
 	test -e $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
@@ -187,13 +201,10 @@
 	$(RM) $(OBJS) $(OBJS_CLEAN) build_date.h $(PROGRAM_NAME) $(PROGRAM_NAME).exe *~ *.gcno *.gcda *.gcov
 
 distclean: clean
-	$(RM) *.pkg.tar.xz
-	$(RM) -r jdupes-*-win*/ jdupes-*-win*.zip
-	$(RM) -r jdupes-*-mac*/ jdupes-*-mac*.zip
-
+	$(RM) *.pkg.tar.*
+	$(RM) -r jdupes-*-*/ jdupes-*-*.zip
+
+chrootpackage:
+	+./chroot_build.sh
 package:
-	+./chroot_build.sh
-winpackage:
-	+./generate_windows_packages.sh
-macpackage:
-	+./generate_mac_packages.sh
+	+./generate_packages.sh

=== debian/changelog ===
jdupes (1.19.1-1) unstable; urgency=medium

  * New upstream version 1.19.1.
  * debian/control: bumped Standards-Version to 4.5.1.
  * debian/tests/control:
      - Added a new test based in package forensics-samples-files.
      - Removed option -T from a test.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 30 Nov 2020 21:20:13 -0300

jdupes (1.19.0-1) unstable; urgency=medium

  * New upstream version 1.19.0.
  * debian/tests/control: added a restriction to last CI test.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 13 Oct 2020 00:09:03 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/jbruchon/jdupes
 Vcs-Browser: https://salsa.debian.org/debian/jdupes

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH_OS),linux)
      export OPT1="ENABLE_DEDUPE=1"
      export OPT2="STATIC_DEDUPE_H=1"
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(OPT1) $(OPT2)

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_auto_test:

=== debian/tests/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Test-Command: jdupes -r testdir
 
 Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
-              jdupes -@1ADHinprlsT $AUTOPKGTEST_TMP/files;
+              jdupes -@1ADHinprls $AUTOPKGTEST_TMP/files;
               tree -C $AUTOPKGTEST_TMP/
 Depends: @, tree:native
 
@@ -25,3 +25,9 @@
               jdupes -@rdNQzo time  -X size+:15 $AUTOPKGTEST_TMP/files;
               tree -C $AUTOPKGTEST_TMP/
 Depends: @, tree:native
+Restrictions: allow-stderr
+
+Test-Command: fsdeploy original-files;
+              jdupes -r $AUTOPKGTEST_TMP/
+Restrictions: allow-stderr
+Depends: @, forensics-samples-files
